/*
** Copyright (c) 2002, Scott Lystig Fritchie.  All rights reserved.
** See the file "LICENSE" at the top of the source distribution for
** full license terms.
**
** NOTICE: This file was generated by the tools of the Erlang Driver
**         toolkit.  Do not edit this file by hand unless you know
**         what you're doing!
**
*/

#ifndef __LIBNET_DRV_H
#define __LIBNET_DRV_H

#ifdef   DRIVER_USING_PTHREADS
#include <pthread.h>
#endif   /* DRIVER_USING_PTHREADS */

/*
** Driver<->emulator communication codes (xref with top of libnet_drv.hrl)
*/

#define _DEBUG                          0
#define _NULL                           1
#define _LIBNET_OPEN_RAW_SOCK           2
#define _LIBNET_CLOSE_RAW_SOCK          3
#define _MY_LIBNET_SELECT_DEVICE_ANY    4
#define _LIBNET_SELECT_DEVICE           5
#define _LIBNET_OPEN_LINK_INTERFACE     6
#define _LIBNET_CLOSE_LINK_INTERFACE    7
#define _LIBNET_WRITE_IP                8
#define _LIBNET_WRITE_LINK_LAYER        9
#define _LIBNET_DO_CHECKSUM             10
#define _LIBNET_IP_CHECK                11
#define _TEST_SEND_PING                 12
#define _TEST_MAKE_ICMP_ECHO_NO_CHECKSUM  13

/*
** Constants
*/

#ifndef LIBNET_ERR_BUF
#define LIBNET_ERR_BUF  128    /* Not defined in Libnet-1.0.2a distribution {sigh} */
#endif
#ifndef IPPROTO_IP
#define IPPROTO_IP      0    /* dummy for IP */
#endif
#ifndef IPPROTO_HOPOPTS
#define IPPROTO_HOPOPTS  0    /* IP6 hop-by-hop options */
#endif
#ifndef IPPROTO_ICMP
#define IPPROTO_ICMP    1    /* control message protocol */
#endif
#ifndef IPPROTO_IGMP
#define IPPROTO_IGMP    2    /* group mgmt protocol */
#endif
#ifndef IPPROTO_GGP
#define IPPROTO_GGP     3    /* gateway^2 (deprecated) */
#endif
#ifndef IPPROTO_IPV4
#define IPPROTO_IPV4    4    /* IPv4 encapsulation */
#endif
#ifndef IPPROTO_TCP
#define IPPROTO_TCP     6    /* tcp */
#endif
#ifndef IPPROTO_ST
#define IPPROTO_ST      7    /* Stream protocol II */
#endif
#ifndef IPPROTO_EGP
#define IPPROTO_EGP     8    /* exterior gateway protocol */
#endif
#ifndef IPPROTO_PIGP
#define IPPROTO_PIGP    9    /* private interior gateway */
#endif
#ifndef IPPROTO_RCCMON
#define IPPROTO_RCCMON  10    /* BBN RCC Monitoring */
#endif
#ifndef IPPROTO_NVPII
#define IPPROTO_NVPII   11    /* network voice protoco */
#endif
#ifndef IPPROTO_PUP
#define IPPROTO_PUP     12    /* pup */
#endif
#ifndef IPPROTO_ARGUS
#define IPPROTO_ARGUS   13    /* Argus */
#endif
#ifndef IPPROTO_EMCON
#define IPPROTO_EMCON   14    /* EMCON */
#endif
#ifndef IPPROTO_XNET
#define IPPROTO_XNET    15    /* Cross Net Debugger */
#endif
#ifndef IPPROTO_CHAOS
#define IPPROTO_CHAOS   16    /* Chao */
#endif
#ifndef IPPROTO_UDP
#define IPPROTO_UDP     17    /* user datagram protocol */
#endif
#ifndef IPPROTO_MUX
#define IPPROTO_MUX     18    /* Multiplexing */
#endif
#ifndef IPPROTO_MEAS
#define IPPROTO_MEAS    19    /* DCN Measurement Subsystems */
#endif
#ifndef IPPROTO_HMP
#define IPPROTO_HMP     20    /* Host Monitoring */
#endif
#ifndef IPPROTO_PRM
#define IPPROTO_PRM     21    /* Packet Radio Measurement */
#endif
#ifndef IPPROTO_IDP
#define IPPROTO_IDP     22    /* xns idp */
#endif
#ifndef IPPROTO_TRUNK1
#define IPPROTO_TRUNK1  23    /* Trunk-1 */
#endif
#ifndef IPPROTO_TRUNK2
#define IPPROTO_TRUNK2  24    /* Trunk-2 */
#endif
#ifndef IPPROTO_LEAF1
#define IPPROTO_LEAF1   25    /* Leaf-1 */
#endif
#ifndef IPPROTO_LEAF2
#define IPPROTO_LEAF2   26    /* Leaf-2 */
#endif
#ifndef IPPROTO_RDP
#define IPPROTO_RDP     27    /* Reliable Data */
#endif
#ifndef IPPROTO_IRTP
#define IPPROTO_IRTP    28    /* Reliable Transaction */
#endif
#ifndef IPPROTO_TP
#define IPPROTO_TP      29    /* tp-4 w/ class negotiation */
#endif
#ifndef IPPROTO_BLT
#define IPPROTO_BLT     30    /* Bulk Data Transfer */
#endif
#ifndef IPPROTO_NSP
#define IPPROTO_NSP     31    /* Network Services */
#endif
#ifndef IPPROTO_INP
#define IPPROTO_INP     32    /* Merit Internodal */
#endif
#ifndef IPPROTO_SEP
#define IPPROTO_SEP     33    /* Sequential Exchange */
#endif
#ifndef IPPROTO_3PC
#define IPPROTO_3PC     34    /* Third Party Connect */
#endif
#ifndef IPPROTO_IDPR
#define IPPROTO_IDPR    35    /* InterDomain Policy Routing */
#endif
#ifndef IPPROTO_XTP
#define IPPROTO_XTP     36    /* XTP */
#endif
#ifndef IPPROTO_DDP
#define IPPROTO_DDP     37    /* Datagram Delivery */
#endif
#ifndef IPPROTO_CMTP
#define IPPROTO_CMTP    38    /* Control Message Transport */
#endif
#ifndef IPPROTO_TPXX
#define IPPROTO_TPXX    39    /* TP++ Transport */
#endif
#ifndef IPPROTO_IL
#define IPPROTO_IL      40    /* IL transport protocol */
#endif
#ifndef IPPROTO_IPV6
#define IPPROTO_IPV6    41    /* IP6 header */
#endif
#ifndef IPPROTO_SDRP
#define IPPROTO_SDRP    42    /* Source Demand Routing */
#endif
#ifndef IPPROTO_ROUTING
#define IPPROTO_ROUTING  43    /* IP6 routing header */
#endif
#ifndef IPPROTO_FRAGMENT
#define IPPROTO_FRAGMENT  44    /* IP6 fragmentation header */
#endif
#ifndef IPPROTO_IDRP
#define IPPROTO_IDRP    45    /* InterDomain Routin */
#endif
#ifndef IPPROTO_RSVP
#define IPPROTO_RSVP    46    /* resource reservation */
#endif
#ifndef IPPROTO_GRE
#define IPPROTO_GRE     47    /* General Routing Encap. */
#endif
#ifndef IPPROTO_MHRP
#define IPPROTO_MHRP    48    /* Mobile Host Routing */
#endif
#ifndef IPPROTO_BHA
#define IPPROTO_BHA     49    /* BHA */
#endif
#ifndef IPPROTO_ESP
#define IPPROTO_ESP     50    /* IP6 Encap Sec. Payload */
#endif
#ifndef IPPROTO_AH
#define IPPROTO_AH      51    /* IP6 Auth Header */
#endif
#ifndef IPPROTO_INLSP
#define IPPROTO_INLSP   52    /* Integ. Net Layer Security */
#endif
#ifndef IPPROTO_SWIPE
#define IPPROTO_SWIPE   53    /* IP with encryption */
#endif
#ifndef IPPROTO_NHRP
#define IPPROTO_NHRP    54    /* Next Hop Resolution */
#endif
#ifndef IPPROTO_ICMPV6
#define IPPROTO_ICMPV6  58    /* ICMP6 */
#endif
#ifndef IPPROTO_NONE
#define IPPROTO_NONE    59    /* IP6 no next header */
#endif
#ifndef IPPROTO_DSTOPTS
#define IPPROTO_DSTOPTS  60    /* IP6 destination option */
#endif
#ifndef IPPROTO_AHIP
#define IPPROTO_AHIP    61    /* any host internal protocol */
#endif
#ifndef IPPROTO_CFTP
#define IPPROTO_CFTP    62    /* CFTP */
#endif
#ifndef IPPROTO_HELLO
#define IPPROTO_HELLO   63    /* 'hello' routing protocol */
#endif
#ifndef IPPROTO_SATEXPAK
#define IPPROTO_SATEXPAK  64    /* SATNET/Backroom EXPAK */
#endif
#ifndef IPPROTO_KRYPTOLAN
#define IPPROTO_KRYPTOLAN  65    /* Kryptolan */
#endif
#ifndef IPPROTO_RVD
#define IPPROTO_RVD     66    /* Remote Virtual Disk */
#endif
#ifndef IPPROTO_IPPC
#define IPPROTO_IPPC    67    /* Pluribus Packet Core */
#endif
#ifndef IPPROTO_ADFS
#define IPPROTO_ADFS    68    /* Any distributed FS */
#endif
#ifndef IPPROTO_SATMON
#define IPPROTO_SATMON  69    /* Satnet Monitoring */
#endif
#ifndef IPPROTO_VISA
#define IPPROTO_VISA    70    /* VISA Protocol */
#endif
#ifndef IPPROTO_IPCV
#define IPPROTO_IPCV    71    /* Packet Core Utility */
#endif
#ifndef IPPROTO_CPNX
#define IPPROTO_CPNX    72    /* Comp. Prot. Net. Executive */
#endif
#ifndef IPPROTO_CPHB
#define IPPROTO_CPHB    73    /* Comp. Prot. HeartBeat */
#endif
#ifndef IPPROTO_WSN
#define IPPROTO_WSN     74    /* Wang Span Network */
#endif
#ifndef IPPROTO_PVP
#define IPPROTO_PVP     75    /* Packet Video Protocol */
#endif
#ifndef IPPROTO_BRSATMON
#define IPPROTO_BRSATMON  76    /* BackRoom SATNET Monitoring */
#endif
#ifndef IPPROTO_ND
#define IPPROTO_ND      77    /* Sun net disk proto (temp.) */
#endif
#ifndef IPPROTO_WBMON
#define IPPROTO_WBMON   78    /* WIDEBAND Monitoring */
#endif
#ifndef IPPROTO_WBEXPAK
#define IPPROTO_WBEXPAK  79    /* WIDEBAND EXPAK */
#endif
#ifndef IPPROTO_EON
#define IPPROTO_EON     80    /* ISO cnlp */
#endif
#ifndef IPPROTO_VMTP
#define IPPROTO_VMTP    81    /* VMTP */
#endif
#ifndef IPPROTO_SVMTP
#define IPPROTO_SVMTP   82    /* Secure VMTP */
#endif
#ifndef IPPROTO_VINES
#define IPPROTO_VINES   83    /* Banyon VINES */
#endif
#ifndef IPPROTO_TTP
#define IPPROTO_TTP     84    /* TTP */
#endif
#ifndef IPPROTO_IGP
#define IPPROTO_IGP     85    /* NSFNET-IGP */
#endif
#ifndef IPPROTO_DGP
#define IPPROTO_DGP     86    /* dissimilar gateway prot. */
#endif
#ifndef IPPROTO_TCF
#define IPPROTO_TCF     87    /* TCF */
#endif
#ifndef IPPROTO_IGRP
#define IPPROTO_IGRP    88    /* Cisco/GXS IGRP */
#endif
#ifndef IPPROTO_OSPFIGP
#define IPPROTO_OSPFIGP  89    /* OSPFIGP */
#endif
#ifndef IPPROTO_SRPC
#define IPPROTO_SRPC    90    /* Strite RPC protocol */
#endif
#ifndef IPPROTO_LARP
#define IPPROTO_LARP    91    /* Locus Address Resoloution */
#endif
#ifndef IPPROTO_MTP
#define IPPROTO_MTP     92    /* Multicast Transport */
#endif
#ifndef IPPROTO_AX25
#define IPPROTO_AX25    93    /* AX.25 Frames */
#endif
#ifndef IPPROTO_IPEIP
#define IPPROTO_IPEIP   94    /* IP encapsulated in IP */
#endif
#ifndef IPPROTO_MICP
#define IPPROTO_MICP    95    /* Mobile Int.ing control */
#endif
#ifndef IPPROTO_SCCSP
#define IPPROTO_SCCSP   96    /* Semaphore Comm. security */
#endif
#ifndef IPPROTO_ETHERIP
#define IPPROTO_ETHERIP  97    /* Ethernet IP encapsulation */
#endif
#ifndef IPPROTO_ENCAP
#define IPPROTO_ENCAP   98    /* encapsulation header */
#endif
#ifndef IPPROTO_APES
#define IPPROTO_APES    99    /* any private encr. scheme */
#endif
#ifndef IPPROTO_GMTP
#define IPPROTO_GMTP    100    /* GMT */
#endif
#ifndef IPPROTO_IPCOMP
#define IPPROTO_IPCOMP  108    /* payload compression (IPComp) */
#endif
#ifndef IPPROTO_PIM
#define IPPROTO_PIM     103    /* Protocol Independent Mcast */
#endif
#ifndef IPPROTO_PGM
#define IPPROTO_PGM     113    /* PGM */
#endif
#ifndef IPPROTO_DIVERT
#define IPPROTO_DIVERT  254    /* divert pseudo-protocol */
#endif
#ifndef IPPROTO_RAW
#define IPPROTO_RAW     255    /* raw IP packet */
#endif
#ifndef IPPROTO_MAX
#define IPPROTO_MAX     256
#endif
#ifndef IPPORT_RESERVED
#define IPPORT_RESERVED  1024
#endif
#ifndef IPPORT_USERRESERVED
#define IPPORT_USERRESERVED  5000
#endif
#ifndef IPPORT_HIFIRSTAUTO
#define IPPORT_HIFIRSTAUTO  49152
#endif
#ifndef IPPORT_HILASTAUTO
#define IPPORT_HILASTAUTO  65535
#endif
#ifndef LIBNET_ARP_H
#define LIBNET_ARP_H    28    /* ARP header: 28 bytes */
#endif
#ifndef LIBNET_DNS_H
#define LIBNET_DNS_H    12    /* DNS header base: 12 bytes */
#endif
#ifndef LIBNET_ETH_H
#define LIBNET_ETH_H    14    /* Etherner header: 14 bytes */
#endif
#ifndef LIBNET_ICMP_H
#define LIBNET_ICMP_H   4    /* ICMP header base: 4 bytes */
#endif
#ifndef LIBNET_ICMP_ECHO_H
#define LIBNET_ICMP_ECHO_H  8    /* ICMP_ECHO header: 8 bytes */
#endif
#ifndef LIBNET_ICMP_MASK_H
#define LIBNET_ICMP_MASK_H  12    /* ICMP_MASK header: 12 bytes */
#endif
#ifndef LIBNET_ICMP_UNREACH_H
#define LIBNET_ICMP_UNREACH_H  8    /* ICMP_UNREACH header: 8 bytes */
#endif
#ifndef LIBNET_ICMP_TIMXCEED_H
#define LIBNET_ICMP_TIMXCEED_H  8    /* ICMP_TIMXCEED header: 8 bytes */
#endif
#ifndef LIBNET_ICMP_REDIRECT_H
#define LIBNET_ICMP_REDIRECT_H  8    /* ICMP_REDIRECT header: 8 bytes */
#endif
#ifndef LIBNET_ICMP_TS_H
#define LIBNET_ICMP_TS_H  20    /* ICMP_TIMESTAMP headr:20 bytes */
#endif
#ifndef LIBNET_IGMP_H
#define LIBNET_IGMP_H   8    /* IGMP header: 8 bytes */
#endif
#ifndef LIBNET_IP_H
#define LIBNET_IP_H     20    /* IP header: 20 bytes */
#endif
#ifndef LIBNET_RIP_H
#define LIBNET_RIP_H    24    /* RIP header base: 24 bytes */
#endif
#ifndef LIBNET_TCP_H
#define LIBNET_TCP_H    20    /* TCP header: 20 bytes */
#endif
#ifndef LIBNET_UDP_H
#define LIBNET_UDP_H    8    /* UDP header: 8 bytes */
#endif
#ifndef LIBNET_VRRP_H
#define LIBNET_VRRP_H   8    /* VRRP header: 8 bytes */
#endif

#define  MAX_BINVS              24      /* XXX dumb constant! */

#define  VALMAP_INUSE           0x01
#define  VALMAP_DELAYED_CLEANUP 0x02

#define  MAX_RETURN_TERMS       64

/*
** descriptor_t = general state for the port
**
*/

struct descriptor {
    ErlDrvPort          port;
    unsigned short      nextxid;        /* Call txn ID for very async calls */
    int                 valmap_raw_sock[32];
    struct libnet_link_int *  valmap_link_int[32];
    ErlDrvBinary        *tofree[MAX_RETURN_TERMS];
    int                 num_tofree;
};

/*
** callstate_t: asychronous call state
**
** TODO: Fill in the struct members of "i" and "o" below.
*/
typedef struct callstate {
    struct callstate    *next;
    int                 cmd;            /* call/command # */
    unsigned int        *key;           /* Not really used */
    void                (*invoke)(void *);
    void                (*free)(void *);
    unsigned short      xid;            /* Only used by as_control()-
                                           initiated funcs */
    /*
    ** Input & output args use a struct simply for convenient
    ** naming & grouping.  There isn't any attempt to get smart about
    ** using a union or anything like that to avoid bloating the size
    ** of these structs with the combined args of a zillion different
    ** functions.  XXX For future use: look into the use of unions
    ** and/or different flavors of callstate_t to avoid structure bloat.
    */
    struct {
        int             __valmap_raw_sock_index;
        int             __valmap_link_int_index;
        unsigned long   __stash[4];
        int             protocol;
        int             fd;
        char *          device;
        struct libnet_link_int *  l;
        u_char *        buf;
        int             len;
        u_short *       buf_u_short;
        char *          src;
        char *          dst;
    } i;
    struct {
        int             __expect;
        int             __expect_errval;
        int             ret_int;
        struct libnet_link_int *  ret_link_int;
        u_short         ret_u_short;
        u_char *        ret_u_char_p;
        struct sockaddr_in  sin;
        char *          o_device;
        char            ebuf[LIBNET_ERR_BUF];
        u_char *        buf;
        int             pkt_len;
    } o;
} callstate_t;

/*
** End of autogenerated code
**  script = ../../edtk/c_h_template.gsl
**  filename = libnet.xml
**  gslgen version = 2.000 Beta 1
**  date = 2005/08/16
**  time = 22:07:21
*/

#endif  /* __LIBNET_DRV_H */
