/*
** Copyright (c) 2002, Scott Lystig Fritchie.  All rights reserved.
** See the file "LICENSE" at the top of the source distribution for
** full license terms.
**
** NOTICE: This file was generated by the tools of the Erlang Driver
**         toolkit.  Do not edit this file by hand unless you know
**         what you're doing!
**
*/

#ifndef __LIBPCAP_DRV_H
#define __LIBPCAP_DRV_H

#ifdef   DRIVER_USING_PTHREADS
#include <pthread.h>
#endif   /* DRIVER_USING_PTHREADS */

/*
** Driver<->emulator communication codes (xref with top of libpcap_drv.hrl)
*/

#define _DEBUG                          0
#define _NULL                           1
#define _PCAP_OPEN_LIVE                 2
#define _PCAP_OPEN_OFFLINE              3
#define _MY_SET_IMMEDIATE               4
#define _MY_SET_SEE_SENT                5
#define _PCAP_SETNONBLOCK               6
#define _PCAP_GETNONBLOCK               7
#define _PCAP_FINDALLDEVS               8
#define _PCAP_LOOKUPDEV                 9
#define _PCAP_LOOKUPNET                 10
#define _MY_PCAP_COMPILE                11
#define _PCAP_SETFILTER                 12
#define _MY_PCAP_FREECODE               13
#define _PCAP_NEXT                      14
#define _PCAP_DATALINK                  15
#define _PCAP_SNAPSHOT                  16
#define _PCAP_IS_SWAPPED                17
#define _PCAP_MAJOR_VERSION             18
#define _PCAP_MINOR_VERSION             19
#define _PCAP_STATS                     20
#define _PCAP_FILENO                    21
#define _PCAP_GETERR                    22
#define _PCAP_CLOSE                     23

/*
** Constants
*/

#ifndef DLT_NULL
#define DLT_NULL        0    /* no link-layer encapsulation */
#endif
#ifndef DLT_EN10MB
#define DLT_EN10MB      1    /* Ethernet (10Mb) */
#endif
#ifndef DLT_EN3MB
#define DLT_EN3MB       2    /* Experimental Ethernet (3Mb) */
#endif
#ifndef DLT_AX25
#define DLT_AX25        3    /* Amateur Radio AX.25 */
#endif
#ifndef DLT_PRONET
#define DLT_PRONET      4    /* Proteon ProNET Token Ring */
#endif
#ifndef DLT_CHAOS
#define DLT_CHAOS       5    /* Chaos */
#endif
#ifndef DLT_IEEE802
#define DLT_IEEE802     6    /* IEEE 802 Networks */
#endif
#ifndef DLT_ARCNET
#define DLT_ARCNET      7    /* ARCNET */
#endif
#ifndef DLT_SLIP
#define DLT_SLIP        8    /* Serial Line IP */
#endif
#ifndef DLT_PPP
#define DLT_PPP         9    /* Point-to-point Protocol */
#endif
#ifndef DLT_FDDI
#define DLT_FDDI        10    /* FDDI */
#endif
#ifndef DLT_ATM_RFC1483
#define DLT_ATM_RFC1483  11    /* LLC/SNAP encapsulated atm */
#endif
#ifndef DLT_RAW
#define DLT_RAW         12    /* raw IP */
#endif
#ifndef DLT_SLIP_BSDOS
#define DLT_SLIP_BSDOS  15    /* BSD/OS Serial Line IP */
#endif
#ifndef DLT_PPP_BSDOS
#define DLT_PPP_BSDOS   16    /* BSD/OS Point-to-point Protocol */
#endif
#ifndef DLT_ATM_CLIP
#define DLT_ATM_CLIP    19    /* Linux Classical-IP over ATM */
#endif
#ifndef DLT_PPP_SERIAL
#define DLT_PPP_SERIAL  50    /* PPP over serial with HDLC encapsulation */
#endif
#ifndef DLT_PPP_ETHER
#define DLT_PPP_ETHER   51    /* PPP over Ethernet */
#endif
#ifndef DLT_C_HDLC
#define DLT_C_HDLC      104    /* Cisco HDLC */
#endif
#ifndef DLT_IEEE802_11
#define DLT_IEEE802_11  105    /* IEEE 802.11 wireless */
#endif
#ifndef DLT_LOOP
#define DLT_LOOP        108    /* OpenBSD loopback */
#endif
#ifndef DLT_LINUX_SLL
#define DLT_LINUX_SLL   113    /* Linux cooked sockets */
#endif
#ifndef DLT_LTALK
#define DLT_LTALK       114    /* LocalTalk */
#endif
#ifndef DLT_ECONET
#define DLT_ECONET      115    /* Acorn Econet */
#endif
#ifndef DLT_IPFILTER
#define DLT_IPFILTER    116    /* OpenBSD ipfilter */
#endif
#ifndef DLT_PFLOG
#define DLT_PFLOG       117    /* OpenBSD */
#endif
#ifndef DLT_CISCO_IOS
#define DLT_CISCO_IOS   118    /* Cisco-internal use */
#endif
#ifndef DLT_PRISM_HEADER
#define DLT_PRISM_HEADER  119    /* 802.11 cards using Prism II chips */
#endif
#ifndef DLT_AIRONET_HEADER
#define DLT_AIRONET_HEADER  120    /* Aeronet 802.11 cards */
#endif

#define  MAX_BINVS              24      /* XXX dumb constant! */

#define  VALMAP_INUSE           0x01
#define  VALMAP_DELAYED_CLEANUP 0x02

#define  MAX_RETURN_TERMS       512

/*
** descriptor_t = general state for the port
**
*/

struct descriptor {
    ErlDrvPort          port;
    unsigned short      nextxid;        /* Call txn ID for very async calls */
    pcap_t *            valmap_pcap_t[32];
    char                valmap_pcap_t_flags[32];
    struct bpf_program *  valmap_bpf_program[32];
    char                valmap_bpf_program_flags[32];
    pthread_mutex_t     mutex;  /* Protect access to valmap flags */
    ErlDrvBinary        *tofree[MAX_RETURN_TERMS];
    int                 num_tofree;
};

/*
** callstate_t: asychronous call state
**
** TODO: Fill in the struct members of "i" and "o" below.
*/
typedef struct callstate {
    struct callstate    *next;
    int                 cmd;            /* call/command # */
    unsigned int        *key;           /* Not really used */
    void                (*invoke)(void *);
    void                (*free)(void *);
    unsigned short      xid;            /* Only used by as_control()-
                                           initiated funcs */
    struct descriptor   *desc;
    int                 refc_bincount;
    ErlDrvBinary        *refc_bin[MAX_BINVS];
    /*
    ** Input & output args use a struct simply for convenient
    ** naming & grouping.  There isn't any attempt to get smart about
    ** using a union or anything like that to avoid bloating the size
    ** of these structs with the combined args of a zillion different
    ** functions.  XXX For future use: look into the use of unions
    ** and/or different flavors of callstate_t to avoid structure bloat.
    */
    struct {
        int             __valmap_pcap_t_index;
        int             __valmap_bpf_program_index;
        unsigned long   __stash[4];
        char *          device;
        int             snaplen;
        int             promisc;
        int             to_ms;
        char *          fname;
        pcap_t *        p;
        u_int           immediate;
        int             see_sent;
        int             nonblock;
        char *          str;
        int             optimize;
        bpf_u_int32     netmask;
        struct bpf_program *  fp;
    } i;
    struct {
        int             __expect;
        int             __expect_errval;
        pcap_t *        ret_pcap_t;
        int             ret_int;
        char *          ret_char_p;
        struct bpf_program *  ret_bpf_program;
        u_char *        ret_u_char;
        char            errbuf[PCAP_ERRBUF_SIZE];
        pcap_if_t *     alldevsp;
        bpf_u_int32     netp;
        bpf_u_int32     mask;
        struct pcap_pkthdr  h;
        struct pcap_stat  ps;
    } o;
} callstate_t;

/*
** End of autogenerated code
**  script = ../../edtk/c_h_template.gsl
**  filename = libpcap.xml
**  gslgen version = 2.000 Beta 1
**  date = 2005/08/16
**  time = 22:07:36
*/

#endif  /* __LIBPCAP_DRV_H */
