%%%----------------------------------------------------------------------
%%% File    : libpcap_drv.hrl
%%% Summary : Erlang driver for the libpcap
%%%
%%%
%%% NOTICE: This file was generated by the tools of the Erlang Driver
%%%         toolkit.  Do not edit this file by hand unless you know
%%%         what you're doing!
%%%
%%% Copyright (c) 2002, Scott Lystig Fritchie.  All rights reserved.
%%% See the file "LICENSE" at the top of the source distribution for
%%% full license terms.
%%%
%%%----------------------------------------------------------------------

-define(DRV_NAME, "libpcap_drv").

-define(MAX_UINT32, 16#FFFFFFFF).

-define(LEN_NUL_TERM, ?MAX_UINT32).

%%%
%%% Driver<->emulator communication codes (xref with top of libpcap_drv.h)
%%%

-define(_DEBUG,                         0).
-define(_NULL,                          1).
-define(_PCAP_OPEN_LIVE,                2).
-define(_PCAP_OPEN_OFFLINE,             3).
-define(_MY_SET_IMMEDIATE,              4).
-define(_MY_SET_SEE_SENT,               5).
-define(_PCAP_SETNONBLOCK,              6).
-define(_PCAP_GETNONBLOCK,              7).
-define(_PCAP_FINDALLDEVS,              8).
-define(_PCAP_LOOKUPDEV,                9).
-define(_PCAP_LOOKUPNET,                10).
-define(_MY_PCAP_COMPILE,               11).
-define(_PCAP_SETFILTER,                12).
-define(_MY_PCAP_FREECODE,              13).
-define(_PCAP_NEXT,                     14).
-define(_PCAP_DATALINK,                 15).
-define(_PCAP_SNAPSHOT,                 16).
-define(_PCAP_IS_SWAPPED,               17).
-define(_PCAP_MAJOR_VERSION,            18).
-define(_PCAP_MINOR_VERSION,            19).
-define(_PCAP_STATS,                    20).
-define(_PCAP_FILENO,                   21).
-define(_PCAP_GETERR,                   22).
-define(_PCAP_CLOSE,                    23).

%%%
%%% Constants
%%%

-ifndef(_DLT_NULL).
-define(_DLT_NULL,                      0).    % no link-layer encapsulation
-endif.
-ifndef(_DLT_EN10MB).
-define(_DLT_EN10MB,                    1).    % Ethernet (10Mb)
-endif.
-ifndef(_DLT_EN3MB).
-define(_DLT_EN3MB,                     2).    % Experimental Ethernet (3Mb)
-endif.
-ifndef(_DLT_AX25).
-define(_DLT_AX25,                      3).    % Amateur Radio AX.25
-endif.
-ifndef(_DLT_PRONET).
-define(_DLT_PRONET,                    4).    % Proteon ProNET Token Ring
-endif.
-ifndef(_DLT_CHAOS).
-define(_DLT_CHAOS,                     5).    % Chaos
-endif.
-ifndef(_DLT_IEEE802).
-define(_DLT_IEEE802,                   6).    % IEEE 802 Networks
-endif.
-ifndef(_DLT_ARCNET).
-define(_DLT_ARCNET,                    7).    % ARCNET
-endif.
-ifndef(_DLT_SLIP).
-define(_DLT_SLIP,                      8).    % Serial Line IP
-endif.
-ifndef(_DLT_PPP).
-define(_DLT_PPP,                       9).    % Point-to-point Protocol
-endif.
-ifndef(_DLT_FDDI).
-define(_DLT_FDDI,                      10).    % FDDI
-endif.
-ifndef(_DLT_ATM_RFC1483).
-define(_DLT_ATM_RFC1483,               11).    % LLC/SNAP encapsulated atm
-endif.
-ifndef(_DLT_RAW).
-define(_DLT_RAW,                       12).    % raw IP
-endif.
-ifndef(_DLT_SLIP_BSDOS).
-define(_DLT_SLIP_BSDOS,                15).    % BSD/OS Serial Line IP
-endif.
-ifndef(_DLT_PPP_BSDOS).
-define(_DLT_PPP_BSDOS,                 16).    % BSD/OS Point-to-point Protocol
-endif.
-ifndef(_DLT_ATM_CLIP).
-define(_DLT_ATM_CLIP,                  19).    % Linux Classical-IP over ATM
-endif.
-ifndef(_DLT_PPP_SERIAL).
-define(_DLT_PPP_SERIAL,                50).    % PPP over serial with HDLC encapsulation
-endif.
-ifndef(_DLT_PPP_ETHER).
-define(_DLT_PPP_ETHER,                 51).    % PPP over Ethernet
-endif.
-ifndef(_DLT_C_HDLC).
-define(_DLT_C_HDLC,                    104).    % Cisco HDLC
-endif.
-ifndef(_DLT_IEEE802_11).
-define(_DLT_IEEE802_11,                105).    % IEEE 802.11 wireless
-endif.
-ifndef(_DLT_LOOP).
-define(_DLT_LOOP,                      108).    % OpenBSD loopback
-endif.
-ifndef(_DLT_LINUX_SLL).
-define(_DLT_LINUX_SLL,                 113).    % Linux cooked sockets
-endif.
-ifndef(_DLT_LTALK).
-define(_DLT_LTALK,                     114).    % LocalTalk
-endif.
-ifndef(_DLT_ECONET).
-define(_DLT_ECONET,                    115).    % Acorn Econet
-endif.
-ifndef(_DLT_IPFILTER).
-define(_DLT_IPFILTER,                  116).    % OpenBSD ipfilter
-endif.
-ifndef(_DLT_PFLOG).
-define(_DLT_PFLOG,                     117).    % OpenBSD
-endif.
-ifndef(_DLT_CISCO_IOS).
-define(_DLT_CISCO_IOS,                 118).    % Cisco-internal use
-endif.
-ifndef(_DLT_PRISM_HEADER).
-define(_DLT_PRISM_HEADER,              119).    % 802.11 cards using Prism II chips
-endif.
-ifndef(_DLT_AIRONET_HEADER).
-define(_DLT_AIRONET_HEADER,            120).    % Aeronet 802.11 cards
-endif.

%%%
%%% Verbatim stuff
%%%


%%%
%%% End of autogenerated code
%%%  script = ../../edtk/hrl_template.gsl
%%%  filename = libpcap.xml
%%%  gslgen version = 2.000 Beta 1
%%%  date = 2005/08/16
%%%  time = 22:07:36
%%%
