
#include	<stdio.h>

#include	<pcap.h>

void do_one_packet(u_char *user, const struct pcap_pkthdr *h, const u_char *p);
void fmt_packet(int count, const u_char *pkt);

int
main(int argc, char *argv[])
{
    char		errbuf[PCAP_ERRBUF_SIZE];
    pcap_t		*p;
    struct pcap_pkthdr	h;
    u_char		*pkt;

    if (argc != 2) {
	fprintf(stderr, "usage: %s tcpdump-capture-file\n", argv[0]);
	exit(1);
    }
    if ((p = pcap_open_offline(argv[1], errbuf)) == NULL) {
	fprintf(stderr, "open_offline: %s\n", errbuf);
	exit(1);
    }
    pcap_loop(p, -1, do_one_packet, NULL);
    pcap_close(p);

    if ((p = pcap_open_offline(argv[1], errbuf)) == NULL) {
	fprintf(stderr, "open_offline: %s\n", errbuf);
	exit(1);
    }
    while ((pkt = (u_char *) pcap_next(p, &h)) != NULL) {
	fmt_packet(0, pkt);
    }
    pcap_close(p);


    exit(0);
}

void
do_one_packet(u_char *user, const struct pcap_pkthdr *h, const u_char *p)
{
    static int	count = 0;
    u_int	caplen = h->caplen;

    count++;
    if (caplen < 12) {
	fprintf(stderr, "Pkt too short!\n");
	exit(2);
    }
    fmt_packet(count, p);
}

void
fmt_packet(int count, const u_char *pkt)
{
    printf("packet %d: dst ether = %02x:%02x:%02x:%02x:%02x:%02x\n",
	   count, pkt[0], pkt[1], pkt[2], pkt[3], pkt[4], pkt[5]);
    printf("packet %d: src ether = %02x:%02x:%02x:%02x:%02x:%02x\n",
	   count, pkt[6], pkt[7], pkt[8], pkt[9], pkt[10], pkt[11]);
    printf("\n");
}
